<%@ Page Language="C#" AutoEventWireup="true" Inherits="_Default" Codebehind="Default.aspx.cs" %>

<%@ Register Assembly="MindFusion.Diagramming.WebForms" Namespace="MindFusion.Diagramming.WebForms" TagPrefix="ndiag" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">

<html xmlns="http://www.w3.org/1999/xhtml">
<head runat="server">
  <title>MindFusion NetDiagram Sample - Organization Browser</title>
  <link href="common/jquery-ui.min.css" rel="stylesheet" />
  <link href="common/samples.css" rel="stylesheet" />
  <script type="text/javascript" src="common/jquery.min.js"></script>
  <script type="text/javascript" src="common/jquery-ui.min.js"></script>
  <script type="text/javascript" src="common/samples.js"></script>
</head>
<body>
<form id="form1" runat="server">

  <asp:ScriptManager ID="ScriptManager1" runat="server">
    <Services>
      <asp:ServiceReference Path="OrgService.asmx" />
    </Services>
  </asp:ScriptManager>
        
  <div id="header" style="height: 49px;">
    <div style="float: right; margin-right: 5px; margin-top: 17px;">
      <button id="expandButton" onclick="onExpandCollapse()">&gt;</button>
    </div>
  </div>

  <div id="info" style="top: 60px; bottom: 24px;">
    <div id="infoTab" style="padding: 10px;">
      <h1>About this sample</h1>
      <p>This sample shows how to make AJAX calls from client side events. Requires Microsoft Ajax extensions for ASP.NET.</p>
      <p>Click on the '+' button near one of the nodes to expand the organization tree.</p>
    </div>
  </div>

  <div id="content" style="top: 60px; bottom: 24px; background-color: #FAFFF9;">
    <ndiag:DiagramView id="fc" runat="server" ClientSideMode="Canvas" style="position: absolute; left: 0px; top: 0px; right: 0px; bottom: 0px;"
		  JsLibraryLocation="Scripts/MindFusion.Diagramming.js" TreeExpandedScript="onTreeExpanded">
      <Diagram AutoResize="RightAndDown" DefaultShape="Rectangle" ShapeHandlesStyle="DashFrame" />
    </ndiag:DiagramView>
  </div>

  <div id="footer" style="height: 24px;">
    <span id="copyright"></span>
  </div>

</form>
    
<script language="javascript" type="text/javascript">
var clickedParent;
        
function onTreeExpanded(sender, args)
{
    var parentNode = args.getNode();

    if (parentNode.getOutgoingLinks().length == 0)
    {
        clickedParent = parentNode;
        setTimeout("callService()", 1);
    }
    else
    {
        var d = $find('fc');
        layoutTree(d);
    }
}
        
function callService()
{
    // explicitly convert the box text to a JavaScript string object
    var parentText = new String(clickedParent.getText()).valueOf();
    Samples.OrgService.GetChildren(parentText, onGotNames, onFailed);
}

function onGotNames(names)
{
    var d = $find('fc');

    var i;
    for (i = 0; i < names.length; ++i)
    {
        var box = d.getFactory().createShapeNode(0, 0, 25, 16);
        box.setText(names[i]);
        box.setExpandable(true);
        box.setExpanded(false);

        var link = d.getFactory().createDiagramLink(clickedParent, box);
        link.setHeadShape(MindFusion.Diagramming.Shapes.Triangle());
    }
            
    layoutTree(d);
            
    var crect = d.getContentBounds();
    crect.width += 5;
    crect.height += 5;
    var drect = d.getBounds();
    if (crect.width > drect.width || crect.height > drect.height)
      d.setBounds(crect.union(drect));
}
        
function onFailed(error)
{
    var stackTrace = error.get_stackTrace();
    var message = error.get_message();
    var statusCode = error.get_statusCode();
    var exceptionType = error.get_exceptionType();
    var timedout = error.get_timedOut();

    alert(
        "Stack Trace: " +  stackTrace + "\n" +
        "Service Error: " + message + "\n" +
        "Status Code: " + statusCode + "\n" +
        "Exception Type: " + exceptionType + "\n" +
        "Timedout: " + timedout);
}

function layoutTree(diagram)
{
    var tl = new MindFusion.Graphs.TreeLayout();
    tl.nodeDistance = 12;
    tl.levelDistance = 8;
    diagram.arrange(tl);
}
</script>

</body>
</html>